Index: branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4.csproj	(revision 7387)
+++ branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4.csproj	(revision 7388)
@@ -40,5 +40,5 @@
     <DebugSymbols>true</DebugSymbols>
     <DebugType>full</DebugType>
-    <Optimize>false</Optimize>
+    <Optimize>true</Optimize>
     <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
@@ -50,5 +50,5 @@
     <DebugType>pdbonly</DebugType>
     <Optimize>true</Optimize>
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -233,9 +233,4 @@
       <Install>true</Install>
     </BootstrapperPackage>
-  </ItemGroup>
-  <ItemGroup>
-    <EmbeddedResource Include="SymbolicExpressionTreeChart.resx">
-      <DependentUpon>SymbolicExpressionTreeChart.cs</DependentUpon>
-    </EmbeddedResource>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs
===================================================================
--- branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs	(revision 7387)
+++ branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs	(revision 7388)
@@ -25,5 +25,4 @@
 using System.Drawing.Imaging;
 using System.Windows.Forms;
-using System.Windows.Forms.VisualStyles;
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views {
@@ -33,5 +32,5 @@
     private Dictionary<ISymbolicExpressionTreeNode, VisualSymbolicExpressionTreeNode> visualTreeNodes;
     private Dictionary<Tuple<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode>, VisualSymbolicExpressionTreeNodeConnection> visualLines;
-    private VisualSymbolicExpressionTreeNode selectedNode;
+    private VisualSymbolicExpressionTreeNode selectedNode = null;
 
     public SymbolicExpressionTreeChart() {
@@ -159,4 +158,12 @@
 
     #region events
+    public event EventHandler SymbolicExpressionTreeNodeChanged;
+    private void OnSymbolicExpressionTreeNodeChanged(object sender, EventArgs e) {
+      var changed = SymbolicExpressionTreeNodeChanged;
+      if (changed != null) {
+        changed(sender, e);
+      }
+    }
+
     public event MouseEventHandler SymbolicExpressionTreeNodeClicked;
     private void OnSymbolicExpressionTreeNodeClicked(object sender, MouseEventArgs e) {
@@ -362,20 +369,6 @@
 
     private void changeValueToolStripMenuItem_Click(object sender, EventArgs e) {
-      var treeNode = selectedNode.SymbolicExpressionTreeNode;
-      // textbox as a popup/tooltip
-      var dialog = new Core.Views.TextDialog("Change value", String.Empty, false);
-      dialog.AutoSize = true;
-      dialog.ShowDialog(this);
-      double newValue;
-      if (double.TryParse(dialog.Text, out newValue)) {
-        if (treeNode.Symbol is Problems.DataAnalysis.Symbolic.Constant) {
-          var node = treeNode as Problems.DataAnalysis.Symbolic.ConstantTreeNode;
-          node.Value = newValue;
-        } else if (treeNode.Symbol is Problems.DataAnalysis.Symbolic.Variable) {
-          var node = treeNode as Problems.DataAnalysis.Symbolic.VariableTreeNode;
-          node.Weight = newValue;
-        }
-      }
-      this.Repaint();
+      if (selectedNode != null) // this should never be null anyway
+        OnSymbolicExpressionTreeNodeChanged(selectedNode, e);
     }
   }
Index: branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj	(revision 7387)
+++ branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj	(revision 7388)
@@ -50,5 +50,5 @@
     <DebugType>pdbonly</DebugType>
     <Optimize>true</Optimize>
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -135,4 +135,10 @@
   <ItemGroup>
     <Compile Include="Plugin.cs" />
+    <Compile Include="SymbolicExpressionTreeNodeChangeValueDialog.cs">
+      <SubType>Form</SubType>
+    </Compile>
+    <Compile Include="SymbolicExpressionTreeNodeChangeValueDialog.designer.cs">
+      <DependentUpon>SymbolicExpressionTreeNodeChangeValueDialog.cs</DependentUpon>
+    </Compile>
     <Compile Include="TextualSymbolicDataAnalysisModelView.cs">
       <SubType>UserControl</SubType>
@@ -211,9 +217,4 @@
     </BootstrapperPackage>
   </ItemGroup>
-  <ItemGroup>
-    <EmbeddedResource Include="InteractiveSymbolicDataAnalysisSolutionSimplifierView.resx">
-      <DependentUpon>InteractiveSymbolicDataAnalysisSolutionSimplifierView.cs</DependentUpon>
-    </EmbeddedResource>
-  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.Designer.cs
===================================================================
--- branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.Designer.cs	(revision 7387)
+++ branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.Designer.cs	(revision 7388)
@@ -51,6 +51,6 @@
       this.btnSimplify = new System.Windows.Forms.Button();
       this.btnOptimizeConstants = new System.Windows.Forms.Button();
+      this.treeChart = new HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views.SymbolicExpressionTreeChart();
       this.grpViewHost = new System.Windows.Forms.GroupBox();
-      this.treeChart = new HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views.SymbolicExpressionTreeChart();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
@@ -64,6 +64,6 @@
       // viewHost
       // 
-      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.viewHost.Caption = "View";
@@ -109,5 +109,5 @@
       // flowLayoutPanel
       // 
-      this.flowLayoutPanel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
+      this.flowLayoutPanel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.flowLayoutPanel.Controls.Add(this.btnSimplify);
@@ -141,19 +141,8 @@
       this.btnOptimizeConstants.Click += new System.EventHandler(this.btnOptimizeConstants_Click);
       // 
-      // grpViewHost
-      // 
-      this.grpViewHost.Controls.Add(this.viewHost);
-      this.grpViewHost.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.grpViewHost.Location = new System.Drawing.Point(0, 0);
-      this.grpViewHost.Name = "grpViewHost";
-      this.grpViewHost.Size = new System.Drawing.Size(347, 348);
-      this.grpViewHost.TabIndex = 1;
-      this.grpViewHost.TabStop = false;
-      this.grpViewHost.Text = "Details";
-      // 
       // treeChart
       // 
-      this.treeChart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.treeChart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.treeChart.BackgroundColor = System.Drawing.Color.White;
@@ -167,6 +156,18 @@
       this.treeChart.TextFont = new System.Drawing.Font("Times New Roman", 8F);
       this.treeChart.Tree = null;
+      this.treeChart.SymbolicExpressionTreeNodeChanged += new System.EventHandler(this.treeChart_SymbolicExpressionTreeNodeChanged);
       this.treeChart.SymbolicExpressionTreeNodeClicked += new System.Windows.Forms.MouseEventHandler(this.treeChart_SymbolicExpressionTreeNodeClicked);
       this.treeChart.SymbolicExpressionTreeNodeDoubleClicked += new System.Windows.Forms.MouseEventHandler(this.treeChart_SymbolicExpressionTreeNodeDoubleClicked);
+      // 
+      // grpViewHost
+      // 
+      this.grpViewHost.Controls.Add(this.viewHost);
+      this.grpViewHost.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.grpViewHost.Location = new System.Drawing.Point(0, 0);
+      this.grpViewHost.Name = "grpViewHost";
+      this.grpViewHost.Size = new System.Drawing.Size(347, 348);
+      this.grpViewHost.TabIndex = 1;
+      this.grpViewHost.TabStop = false;
+      this.grpViewHost.Text = "Details";
       // 
       // InteractiveSymbolicDataAnalysisSolutionSimplifierView
Index: branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.cs
===================================================================
--- branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.cs	(revision 7387)
+++ branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.cs	(revision 7388)
@@ -34,4 +34,5 @@
     private Dictionary<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode> replacementNodes;
     private Dictionary<ISymbolicExpressionTreeNode, double> nodeImpacts;
+    private Dictionary<ISymbolicExpressionTreeNode, double> originalValues;
     private bool updateInProgress = false;
 
@@ -40,4 +41,5 @@
       this.replacementNodes = new Dictionary<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode>();
       this.nodeImpacts = new Dictionary<ISymbolicExpressionTreeNode, double>();
+      this.originalValues = new Dictionary<ISymbolicExpressionTreeNode, double>();
       this.Caption = "Interactive Solution Simplifier";
     }
@@ -92,5 +94,5 @@
 
         if (!updateInProgress) {
-          // automatically fold all branches with impact = 1
+          // automatically fold all branches with impact = 0
           List<ISymbolicExpressionTreeNode> nodeList = Content.Model.SymbolicExpressionTree.Root.GetSubtree(0).IterateNodesPrefix().ToList();
           foreach (var parent in nodeList) {
@@ -129,4 +131,21 @@
       VisualSymbolicExpressionTreeNode visualTreeNode = (VisualSymbolicExpressionTreeNode)sender;
       var tree = Content.Model.SymbolicExpressionTree;
+      // check if the node value/weight has been altered
+      // if so, the first double click will return the node to its original value/weight
+      // the next double click will replace the ConstantNode with the original SymbolicExpressionTreeNode
+      if (originalValues.ContainsKey(visualTreeNode.SymbolicExpressionTreeNode)) {
+        double value = originalValues[visualTreeNode.SymbolicExpressionTreeNode];
+        var subTree = visualTreeNode.SymbolicExpressionTreeNode;
+        if (subTree.Symbol is Constant)
+          (subTree as ConstantTreeNode).Value = value;
+        else if (subTree.Symbol is Variable)
+          (subTree as VariableTreeNode).Weight = value;
+        originalValues.Remove(subTree);
+        updateInProgress = true;
+        UpdateModel(tree);
+        updateInProgress = false;
+        return;
+      }
+
       foreach (SymbolicExpressionTreeNode treeNode in tree.IterateNodesPostfix()) {
         for (int i = 0; i < treeNode.SubtreeCount; i++) {
@@ -153,25 +172,50 @@
     private void treeChart_SymbolicExpressionTreeNodeClicked(object sender, MouseEventArgs e) {
       if (e.Button == MouseButtons.Right) {
-        var visualTreeNode = sender as VisualSymbolicExpressionTreeNode;
-        var node = visualTreeNode.SymbolicExpressionTreeNode;
-        // on a right click we want to show the option of changing the node value (if the node is a constant) or the weight (if the node is a variable)
+        var node = (sender as VisualSymbolicExpressionTreeNode).SymbolicExpressionTreeNode;
         var menu = treeChart.ContextMenuStrip;
+
+        bool flag = (node.Symbol is Constant || node.Symbol is Variable);
+
         ToolStripItem[] items = menu.Items.Find("changeValueToolStripMenuItem", false);
         ToolStripItem changeValueMenuItem = null;
-        if (items.Length > 0) {
+        if (items.Any())
           changeValueMenuItem = items[0];
-        }
-
-        if (node.Symbol is Constant || node.Symbol is Variable) {
-          if (changeValueMenuItem != null) {
-            changeValueMenuItem.Enabled = true;
-            changeValueMenuItem.Visible = true;
-          }
-        } else {
-          if (changeValueMenuItem != null) {
-            changeValueMenuItem.Enabled = false;
-            changeValueMenuItem.Visible = false;
-          }
-        }
+        if (changeValueMenuItem != null) {
+          changeValueMenuItem.Enabled = flag;
+          changeValueMenuItem.Visible = flag;
+        }
+      }
+    }
+
+    private void treeChart_SymbolicExpressionTreeNodeChanged(object sender, EventArgs e) {
+      var tree = Content.Model.SymbolicExpressionTree;
+      var visualTreeNode = sender as VisualSymbolicExpressionTreeNode;
+      var subTree = visualTreeNode.SymbolicExpressionTreeNode;
+      string title = String.Empty;
+      double value = 0.0;
+
+      if (subTree.Symbol is Constant) {
+        title = "Change Constant Value";
+        value = (subTree as ConstantTreeNode).Value;
+      } else if (subTree.Symbol is Variable) {
+        title = "Change Weight Value";
+        value = (subTree as VariableTreeNode).Weight;
+      }
+
+      if (!originalValues.ContainsKey(subTree))
+        originalValues.Add(subTree, value);
+      var dialog = new ValueChangeDialog(title, Math.Round(value,4).ToString());
+      dialog.ShowDialog(this);
+      if (dialog.DialogResult == DialogResult.OK) {
+        value = double.Parse(dialog.NewValue);
+        if (subTree.Symbol is Constant)
+          (subTree as ConstantTreeNode).Value = value;
+        else if (subTree.Symbol is Variable)
+          (subTree as VariableTreeNode).Weight = value;
+        // show only interesting part of solution 
+        treeChart.Tree = tree.Root.SubtreeCount > 1 ? new SymbolicExpressionTree(tree.Root) : new SymbolicExpressionTree(tree.Root.GetSubtree(0).GetSubtree(0));
+        updateInProgress = true;
+        UpdateModel(tree);
+        updateInProgress = false;
       }
     }
@@ -223,5 +267,7 @@
     private void PaintCollapsedNodes() {
       foreach (ISymbolicExpressionTreeNode treeNode in Content.Model.SymbolicExpressionTree.IterateNodesPostfix()) {
-        if (treeNode is ConstantTreeNode && replacementNodes.ContainsKey(treeNode))
+        if (originalValues.ContainsKey(treeNode)) 
+          this.treeChart.GetVisualSymbolicExpressionTreeNode(treeNode).LineColor = Color.Blue;
+        else if (treeNode is ConstantTreeNode && replacementNodes.ContainsKey(treeNode))
           this.treeChart.GetVisualSymbolicExpressionTreeNode(treeNode).LineColor = Color.DarkOrange;
         else {
Index: branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SymbolicExpressionTreeNodeChangeValueDialog.Designer.cs
===================================================================
--- branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SymbolicExpressionTreeNodeChangeValueDialog.Designer.cs	(revision 7388)
+++ branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SymbolicExpressionTreeNodeChangeValueDialog.Designer.cs	(revision 7388)
@@ -0,0 +1,145 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views {
+  partial class ValueChangeDialog {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
+      this.okButton = new System.Windows.Forms.Button();
+      this.oldValueLabel = new System.Windows.Forms.Label();
+      this.oldValueTextBox = new System.Windows.Forms.TextBox();
+      this.newValueTextBox = new System.Windows.Forms.TextBox();
+      this.newValueLabel = new System.Windows.Forms.Label();
+      this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // okButton
+      // 
+      this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
+      this.okButton.Enabled = false;
+      this.okButton.Location = new System.Drawing.Point(66, 74);
+      this.okButton.Name = "okButton";
+      this.okButton.Size = new System.Drawing.Size(75, 23);
+      this.okButton.TabIndex = 0;
+      this.okButton.Text = "&OK";
+      this.okButton.UseVisualStyleBackColor = true;
+      this.okButton.Click += new System.EventHandler(this.okButton_Click);
+      // 
+      // oldValueLabel
+      // 
+      this.oldValueLabel.AutoSize = true;
+      this.oldValueLabel.Location = new System.Drawing.Point(14, 15);
+      this.oldValueLabel.Name = "oldValueLabel";
+      this.oldValueLabel.Size = new System.Drawing.Size(53, 13);
+      this.oldValueLabel.TabIndex = 2;
+      this.oldValueLabel.Text = "Old Value";
+      // 
+      // oldValueTextBox
+      // 
+      this.oldValueTextBox.Location = new System.Drawing.Point(91, 12);
+      this.oldValueTextBox.Name = "oldValueTextBox";
+      this.oldValueTextBox.ReadOnly = true;
+      this.oldValueTextBox.Size = new System.Drawing.Size(100, 20);
+      this.oldValueTextBox.TabIndex = 3;
+      // 
+      // newValueTextBox
+      // 
+      this.newValueTextBox.Location = new System.Drawing.Point(91, 38);
+      this.newValueTextBox.Name = "newValueTextBox";
+      this.newValueTextBox.Size = new System.Drawing.Size(100, 20);
+      this.newValueTextBox.TabIndex = 4;
+      this.newValueTextBox.KeyDown += new System.Windows.Forms.KeyEventHandler(this.newValueTextBox_KeyDown);
+      this.newValueTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.newValueTextBox_Validating);
+      this.newValueTextBox.Validated += new System.EventHandler(this.newValueTextBox_Validated);
+      // 
+      // newValueLabel
+      // 
+      this.newValueLabel.AutoSize = true;
+      this.newValueLabel.Location = new System.Drawing.Point(8, 41);
+      this.newValueLabel.Name = "newValueLabel";
+      this.newValueLabel.Size = new System.Drawing.Size(59, 13);
+      this.newValueLabel.TabIndex = 5;
+      this.newValueLabel.Text = "New Value";
+      // 
+      // errorProvider
+      // 
+      this.errorProvider.BlinkStyle = System.Windows.Forms.ErrorBlinkStyle.NeverBlink;
+      this.errorProvider.ContainerControl = this;
+      this.errorProvider.RightToLeft = true;
+      // 
+      // ValueChangeDialog
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.AutoSize = true;
+      this.ClientSize = new System.Drawing.Size(209, 109);
+      this.Controls.Add(this.newValueLabel);
+      this.Controls.Add(this.newValueTextBox);
+      this.Controls.Add(this.oldValueTextBox);
+      this.Controls.Add(this.oldValueLabel);
+      this.Controls.Add(this.okButton);
+      this.MaximizeBox = false;
+      this.MinimizeBox = false;
+      this.Name = "ValueChangeDialog";
+      this.ShowIcon = false;
+      this.ShowInTaskbar = false;
+      this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
+      this.Text = "Change Value or Weight";
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    protected System.Windows.Forms.Button okButton;
+    private System.Windows.Forms.Label oldValueLabel;
+    private System.Windows.Forms.TextBox oldValueTextBox;
+    private System.Windows.Forms.TextBox newValueTextBox;
+    private System.Windows.Forms.Label newValueLabel;
+    private System.Windows.Forms.ErrorProvider errorProvider;
+  }
+}
Index: branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SymbolicExpressionTreeNodeChangeValueDialog.cs
===================================================================
--- branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SymbolicExpressionTreeNodeChangeValueDialog.cs	(revision 7388)
+++ branches/HeuristicLab.TreeSimplifierView/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SymbolicExpressionTreeNodeChangeValueDialog.cs	(revision 7388)
@@ -0,0 +1,110 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.ComponentModel;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Common;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views {
+  public partial class ValueChangeDialog : Form {
+    public string Caption {
+      get { return this.Text; }
+      set {
+        if (InvokeRequired)
+          Invoke(new Action<string>(x => this.Caption = x), value);
+        else
+          this.Text = value;
+      }
+    }
+    public string OldValue {
+      get { return oldValueTextBox.Text; }
+      set {
+        if (InvokeRequired)
+          Invoke(new Action<string>(x => this.NewValue = x), value);
+        else
+          oldValueTextBox.Text = value;
+      }
+    }
+    public string NewValue {
+      get { return newValueTextBox.Text; }
+      set {
+        if (InvokeRequired)
+          Invoke(new Action<string>(x => this.NewValue = x), value);
+        else
+          newValueTextBox.Text = value;
+      }
+    }
+
+    public ValueChangeDialog() {
+      InitializeComponent();
+    }
+    public ValueChangeDialog(string caption, string oldValue)
+      : this() {
+      Caption = caption;
+      OldValue = oldValue;
+      NewValue = string.Empty;
+    }
+
+    protected virtual void okButton_Click(object sender, EventArgs e) {
+      Close();
+    }
+
+    private void newValueTextBox_KeyDown(object sender, KeyEventArgs e) {
+      if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
+        newValueLabel.Select();  // select label to validate data
+
+      if (e.KeyCode == Keys.Escape) {
+        newValueTextBox.Text = String.Empty;
+        newValueLabel.Select();  // select label to validate data
+      }
+    }
+    private void newValueTextBox_Validating(object sender, CancelEventArgs e) {
+      string errorMessage;
+      if (!Validate(newValueTextBox.Text, out errorMessage)) {
+        e.Cancel = true;
+        okButton.Enabled = false;
+        errorProvider.SetError(newValueTextBox, errorMessage);
+        newValueTextBox.SelectAll();
+      }
+    }
+    private void newValueTextBox_Validated(object sender, EventArgs e) {
+      errorProvider.SetError(newValueTextBox, string.Empty);
+      okButton.Enabled = true;
+    }
+
+    private static bool Validate(string value, out string errorMessage) {
+      double val;
+      bool valid = double.TryParse(value, out val);
+      errorMessage = string.Empty;
+      if (!valid) {
+        var sb = new StringBuilder();
+        sb.Append("Invalid Value (Valid Value Format: \"");
+        sb.Append(FormatPatterns.GetDoubleFormatPattern());
+        sb.Append("\")");
+        errorMessage = sb.ToString();
+      }
+      return valid;
+    }
+  }
+}