Index: /branches/HiveHiveEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/ParallelIslandGeneticAlgorithmMainLoop.cs
===================================================================
--- /branches/HiveHiveEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/ParallelIslandGeneticAlgorithmMainLoop.cs	(revision 7393)
+++ /branches/HiveHiveEngine/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/ParallelIslandGeneticAlgorithmMainLoop.cs	(revision 7394)
@@ -158,5 +158,5 @@
       VariableCreator islandVariableCreator = new VariableCreator();
       Placeholder islandAnalyzer1 = new Placeholder();
-      LocalRandomGenerator localRandomGenerator = new LocalRandomGenerator();
+      LocalRandomCreator localRandomCreator = new LocalRandomCreator();
       Placeholder analyzer1 = new Placeholder();
       ResultsCollector resultsCollector1 = new ResultsCollector();
@@ -313,6 +313,6 @@
       uniformSubScopesProcessor0.Successor = analyzer1;
       islandVariableCreator.Successor = islandAnalyzer1;
-      islandAnalyzer1.Successor = localRandomGenerator;
-      localRandomGenerator.Successor = null;
+      islandAnalyzer1.Successor = localRandomCreator;
+      localRandomCreator.Successor = null;
       analyzer1.Successor = resultsCollector1;
       resultsCollector1.Successor = uniformSubScopesProcessor1;
Index: /branches/HiveHiveEngine/HeuristicLab.Operators.Views/3.3/ReductionOperationView.Designer.cs
===================================================================
--- /branches/HiveHiveEngine/HeuristicLab.Operators.Views/3.3/ReductionOperationView.Designer.cs	(revision 7393)
+++ /branches/HiveHiveEngine/HeuristicLab.Operators.Views/3.3/ReductionOperationView.Designer.cs	(revision 7394)
@@ -54,22 +54,22 @@
       this.valueLabel.Location = new System.Drawing.Point(3, 3);
       this.valueLabel.Name = "valueLabel";
-      this.valueLabel.Size = new System.Drawing.Size(34, 13);
+      this.valueLabel.Size = new System.Drawing.Size(56, 13);
       this.valueLabel.TabIndex = 0;
-      this.valueLabel.Text = "&Type:";
+      this.valueLabel.Text = "&Operation:";
       // 
       // valueComboBox
       // 
-      this.valueComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.valueComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.valueComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.valueComboBox.Enabled = false;
       this.valueComboBox.FormattingEnabled = true;
-      this.valueComboBox.Location = new System.Drawing.Point(46, 0);
+      this.valueComboBox.Location = new System.Drawing.Point(65, 0);
       this.valueComboBox.Name = "valueComboBox";
-      this.valueComboBox.Size = new System.Drawing.Size(219, 21);
+      this.valueComboBox.Size = new System.Drawing.Size(212, 21);
       this.valueComboBox.TabIndex = 1;
       this.valueComboBox.SelectedIndexChanged += new System.EventHandler(this.valueComboBox_SelectedIndexChanged);
       // 
-      // PermutationTypeView
+      // ReductionOperationView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
@@ -78,5 +78,5 @@
       this.Controls.Add(this.valueLabel);
       this.Name = "ReductionOperationView";
-      this.Size = new System.Drawing.Size(265, 29);
+      this.Size = new System.Drawing.Size(277, 29);
       this.ResumeLayout(false);
       this.PerformLayout();
Index: /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj
===================================================================
--- /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 7393)
+++ /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 7394)
@@ -118,5 +118,5 @@
     <Compile Include="Assigner.cs" />
     <Compile Include="AlgorithmOperator.cs" />
-    <Compile Include="LocalRandomGenerator.cs" />
+    <Compile Include="LocalRandomCreator.cs" />
     <Compile Include="DataReducer.cs" />
     <Compile Include="ReductionOperation.cs" />
Index: /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/LocalRandomCreator.cs
===================================================================
--- /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/LocalRandomCreator.cs	(revision 7394)
+++ /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/LocalRandomCreator.cs	(revision 7394)
@@ -0,0 +1,65 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Operators {
+  [Item("LocalRandomCreator", "Creates a local pseudo random number generator from a global random number generator.")]
+  [StorableClass]
+  public sealed class LocalRandomCreator : SingleSuccessorOperator {
+    #region Parameter Properties
+    public LookupParameter<IRandom> GlobalRandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["GlobalRandom"]; }
+    }
+    public LookupParameter<IRandom> LocalRandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["LocalRandom"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private LocalRandomCreator(bool deserializing) : base(deserializing) { }
+    private LocalRandomCreator(LocalRandomCreator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public LocalRandomCreator()
+      : base() {
+      #region Create parameters
+      Parameters.Add(new LookupParameter<IRandom>("GlobalRandom", "The global random number generator which is used to initialize the local random number generator."));
+      Parameters.Add(new LookupParameter<IRandom>("LocalRandom", "The local pseudo random number generator."));
+      #endregion
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new LocalRandomCreator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      IRandom globalRandom = GlobalRandomParameter.ActualValue;
+      IRandom localRandom = (IRandom)globalRandom.Clone();
+      localRandom.Reset(globalRandom.Next());
+      LocalRandomParameter.ActualValue = localRandom;
+      return base.Apply();
+    }
+  }
+}
Index: anches/HiveHiveEngine/HeuristicLab.Operators/3.3/LocalRandomGenerator.cs
===================================================================
--- /branches/HiveHiveEngine/HeuristicLab.Operators/3.3/LocalRandomGenerator.cs	(revision 7393)
+++ 	(revision )
@@ -1,65 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Operators {
-  [Item("LocalRandomGenerator", "Creates local pseudo random number generator from a global random number generator.")]
-  [StorableClass]
-  public sealed class LocalRandomGenerator : SingleSuccessorOperator {
-    #region Parameter Properties
-    public LookupParameter<IRandom> GlobalRandomParameter {
-      get { return (LookupParameter<IRandom>)Parameters["GlobalRandom"]; }
-    }
-    public LookupParameter<IRandom> LocalRandomParameter {
-      get { return (LookupParameter<IRandom>)Parameters["LocalRandom"]; }
-    }
-    #endregion
-
-    [StorableConstructor]
-    private LocalRandomGenerator(bool deserializing) : base(deserializing) { }
-    private LocalRandomGenerator(LocalRandomGenerator original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public LocalRandomGenerator()
-      : base() {
-      #region Create parameters
-      Parameters.Add(new LookupParameter<IRandom>("GlobalRandom", "The global random number generator which is used to initialize the local random number generator.", "GlobalRandom"));
-      Parameters.Add(new LookupParameter<IRandom>("LocalRandom", "The local pseudo random number generator."));
-      #endregion
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new LocalRandomGenerator(this, cloner);
-    }
-
-    public override IOperation Apply() {
-      IRandom globalRandom = GlobalRandomParameter.ActualValue;
-      IRandom localRandom = (IRandom)globalRandom.Clone();
-      localRandom.Reset(globalRandom.Next());
-      LocalRandomParameter.ActualValue = localRandom;
-      return base.Apply();
-    }
-  }
-}