Index: /branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/SymbolicRegressionSolutionView.Designer.cs
===================================================================
--- /branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/SymbolicRegressionSolutionView.Designer.cs	(revision 7398)
+++ /branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/SymbolicRegressionSolutionView.Designer.cs	(revision 7399)
@@ -36,7 +36,7 @@
       // 
       // 
-      // splitContainer.Panel2
+      // splitContainer.Panel1
       // 
-      this.splitContainer.Panel2.Controls.Add(this.btnSimplify);
+      this.splitContainer.Panel1.Controls.Add(this.btnSimplify);
       this.splitContainer.Size = new System.Drawing.Size(480, 275);
       this.splitContainer.SplitterDistance = 255;
@@ -68,5 +68,6 @@
       // btnSimplify
       // 
-      this.btnSimplify.Location = new System.Drawing.Point(3, 4);
+      this.btnSimplify.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.btnSimplify.Location = new System.Drawing.Point(177, 4);
       this.btnSimplify.Name = "btnSimplify";
       this.btnSimplify.Size = new System.Drawing.Size(75, 23);
Index: /branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/NamedDataAnalysisSolutionView.cs
===================================================================
--- /branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/NamedDataAnalysisSolutionView.cs	(revision 7398)
+++ /branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/NamedDataAnalysisSolutionView.cs	(revision 7399)
@@ -56,4 +56,6 @@
         if (viewType != null) {
           view = (DataAnalysisSolutionView)Activator.CreateInstance(viewType);
+          view.Locked = this.Locked;
+          view.ReadOnly = this.ReadOnly;
           view.Dock = DockStyle.Fill;
           view.Content = Content;
Index: /branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs
===================================================================
--- /branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs	(revision 7398)
+++ /branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.Designer.cs	(revision 7399)
@@ -58,7 +58,7 @@
       // 
       // 
-      // splitContainer.Panel1
+      // splitContainer.Panel2
       // 
-      this.splitContainer.Panel1.Controls.Add(this.btnImport);
+      this.splitContainer.Panel2.Controls.Add(this.btnImport);
       // 
       // itemsGroupBox
@@ -76,6 +76,5 @@
       // btnImport
       // 
-      this.btnImport.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.btnImport.Location = new System.Drawing.Point(172, 4);
+      this.btnImport.Location = new System.Drawing.Point(3, 4);
       this.btnImport.Name = "btnImport";
       this.btnImport.Size = new System.Drawing.Size(75, 23);
Index: /branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs
===================================================================
--- /branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs	(revision 7398)
+++ /branches/ChangeDatasetOfRegressionModel/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs	(revision 7399)
@@ -43,4 +43,9 @@
     }
 
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      btnImport.Enabled = !Locked && !ReadOnly && Content != null;
+    }
+
     #region drag and drop
     protected override void itemsListView_DragEnter(object sender, DragEventArgs e) {
@@ -67,27 +72,37 @@
         }
 
-        IRegressionProblemData problemData = null;
-        if (hlFile != null && hlFile is RegressionProblemData) {
-          problemData = (RegressionProblemData)hlFile;
-        } else if (hlFile != null && hlFile is IRegressionProblem) {
-          problemData = ((IRegressionProblem)hlFile).ProblemData;
-        }
-        if (problemData != null) {
-          StringBuilder message = new StringBuilder();
-          if (!problemData.TargetVariable.Equals(Content.ProblemData.TargetVariable))
-            message.AppendLine("The target variables are not matching. Old target variable: '" + Content.ProblemData.TargetVariable
-              + "'. New targetvariable: '" + problemData.TargetVariable + "'");
-
-          List<string> variables = problemData.InputVariables.Select(x => x.Value).ToList();
-
-          foreach (var item in Content.ProblemData.InputVariables.CheckedItems) {
-            if (!variables.Contains(item.Value.Value))
-              message.AppendLine("Input variable '" + item.Value.Value + "' is not in the new problem data.");
+        if (hlFile != null) {
+          IRegressionProblemData problemData = null;
+          if (hlFile is RegressionProblemData) {
+            problemData = (RegressionProblemData)hlFile;
+          } else if (hlFile is IRegressionProblem) {
+            problemData = ((IRegressionProblem)hlFile).ProblemData;
+          } else if (hlFile is IRegressionSolution) {
+            problemData = ((IRegressionSolution)hlFile).ProblemData;
           }
 
-          if (message.Length != 0)
-            ErrorHandling.ShowErrorDialog(this, new Exception(message.ToString()));
-          else
-            Content.ProblemData = problemData;
+          if (problemData == null) {
+            ErrorHandling.ShowErrorDialog(this,
+              new NullReferenceException("The problem data is null." + Environment.NewLine
+                                       + "The .hl-file is no RegressionProblemData or RegressionProblem."));
+          } else {
+            StringBuilder message = new StringBuilder();
+            if (!problemData.TargetVariable.Equals(Content.ProblemData.TargetVariable))
+              message.AppendLine("The target variables are not matching. Old target variable: '"
+                               + Content.ProblemData.TargetVariable
+                               + "'. New targetvariable: '" + problemData.TargetVariable + "'");
+
+            List<string> variables = problemData.InputVariables.Select(x => x.Value).ToList();
+
+            foreach (var item in Content.ProblemData.InputVariables.CheckedItems) {
+              if (!variables.Contains(item.Value.Value))
+                message.AppendLine("Input variable '" + item.Value.Value + "' is not in the new problem data.");
+            }
+
+            if (message.Length != 0)
+              ErrorHandling.ShowErrorDialog(this, new Exception(message.ToString()));
+            else
+              Content.ProblemData = problemData;
+          }
         }
       }